## ros-galactic-velodyne-driver 2.3.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(velodyne_driver)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

find_package(ament_cmake_ros REQUIRED)
find_package(diagnostic_msgs REQUIRED)
find_package(diagnostic_updater REQUIRED)
find_package(rclcpp REQUIRED)
find_package(rclcpp_components REQUIRED)
find_package(tf2_ros REQUIRED)
find_package(velodyne_msgs REQUIRED)

# libpcap provides no pkg-config or find_package module:
set(libpcap_LIBRARIES -lpcap)

include_directories(include)

# compile the driver and input library
add_subdirectory(src/lib)

# build the driver node
add_library(velodyne_driver SHARED src/driver/driver.cpp)
ament_target_dependencies(velodyne_driver
  diagnostic_msgs
  diagnostic_updater
  rclcpp
  rclcpp_components
  tf2_ros
  velodyne_msgs
)
target_link_libraries(velodyne_driver velodyne_input)

add_executable(velodyne_driver_node src/driver/velodyne_node.cpp)
ament_target_dependencies(velodyne_driver_node
  rclcpp
)
target_link_libraries(velodyne_driver_node velodyne_driver)

# install runtime and library files
install(TARGETS velodyne_driver
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)
install(TARGETS velodyne_driver_node
  DESTINATION lib/${PROJECT_NAME}
)

rclcpp_components_register_nodes(velodyne_driver
  "velodyne_driver::VelodyneDriver")

install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION include/${PROJECT_NAME})

install(DIRECTORY config launch
  DESTINATION share/${PROJECT_NAME})
install(PROGRAMS src/vdump
  DESTINATION lib/${PROJECT_NAME})


if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()

  find_package(ament_cmake_gtest REQUIRED)

  # unit test
  ament_add_gtest(time_test tests/timeconversiontest.cpp)
  target_link_libraries(time_test velodyne_input)

  # Download packet capture (PCAP) files containing test data.
  # Store them in devel-space, so rostest can easily find them.
  # catkin_download_test_data(
  #   ${PROJECT_NAME}_tests_class.pcap
  #   http://download.ros.org/data/velodyne/class.pcap
  #   DESTINATION ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}/tests
  #   MD5 65808d25772101358a3719b451b3d015)
  # catkin_download_test_data(
  #   ${PROJECT_NAME}_tests_32e.pcap
  #   http://download.ros.org/data/velodyne/32e.pcap
  #   DESTINATION ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}/tests
  #   MD5 e41d02aac34f0967c03a5597e1d554a9)
  # catkin_download_test_data(
  #   ${PROJECT_NAME}_tests_vlp16.pcap
  #   http://download.ros.org/data/velodyne/vlp16.pcap
  #   DESTINATION ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}/tests
  #   MD5 f45c2bb1d7ee358274e423ea3b66fd73)

  # unit tests
  # add_rostest(tests/pcap_node_hertz.test)
  # add_rostest(tests/pcap_nodelet_hertz.test)
  # add_rostest(tests/pcap_32e_node_hertz.test)
  # add_rostest(tests/pcap_32e_nodelet_hertz.test)
  # add_rostest(tests/pcap_vlp16_node_hertz.test)
  # add_rostest(tests/pcap_vlp16_nodelet_hertz.test)

  # parse check all the launch/*.launch files
  # roslaunch_add_file_check(launch)
endif()

ament_package()

=== src/lib/CMakeLists.txt ===
add_library(velodyne_input SHARED input.cpp)
ament_target_dependencies(velodyne_input
  rclcpp
  velodyne_msgs
)
target_link_libraries(velodyne_input
  ${libpcap_LIBRARIES}
)

install(TARGETS velodyne_input
  LIBRARY DESTINATION lib
)

=== debian/changelog ===
ros-galactic-velodyne-driver (2.3.0-1focal) focal; urgency=high

  * Updating maintainer email address. (#450 <https://github.com/ros-drivers/velodyne/issues/450>)
    * Updating maintainer email address.
    * chore: update maintainer email address
    Co-authored-by: Joshua Whitley <mailto:jwhitley@autonomoustuff.com>
  * fix: use rclcpp logger instead of perror
    Co-authored-by: Chris Lalancette <mailto:clalancette@gmail.com>
  * reuse Velodyne UDP port (#427 <https://github.com/ros-drivers/velodyne/issues/427>)
  * Added config option to timestamp a full scan based on first velo packet instead of last packet (#436 <https://github.com/ros-drivers/velodyne/issues/436>)
    Co-authored-by: Shawn Hanna <mailto:shawn@kaarta.com>
  * Replace deprecated argument names in launch (#430 <https://github.com/ros-drivers/velodyne/issues/430>)
  * 2.1.1
  * Updating for first Galactic release
  * Minor fixes to string formatting. (#396 <https://github.com/ros-drivers/velodyne/issues/396>)
    These changes will allow velodyne to compile without warnings
    on Rolling (soon to be Galactic).  The changes are also backwards
    compatible to Foxy if we want to backport them.
  * Contributors: Chris Lalancette, Daisuke Nishimatsu, Joshua Whitley, Keane Quigley, Nagy Dániel Zoltán

 -- Josh Whitley <whitleysoftwareservices@gmail.com>  Fri, 08 Jul 2022 05:00:00 -0000

ros-galactic-velodyne-driver (2.1.1-1focal) focal; urgency=high

  * Minor fixes to string formatting. (#396 <https://github.com/ros-drivers/velodyne/issues/396>)
    These changes will allow velodyne to compile without warnings
    on Rolling (soon to be Galactic).  The changes are also backwards
    compatible to Foxy if we want to backport them.
  * Contributors: Chris Lalancette

 -- Josh Whitley <jwhitley@autonomoustuff.com>  Mon, 23 Aug 2021 05:00:00 -0000

ros-galactic-velodyne-driver (2.1.0-1focal) focal; urgency=high

  * Fixing Foxy-specific uncrustify errors.
  * Contributors: Joshua Whitley

 -- Josh Whitley <jwhitley@autonomoustuff.com>  Fri, 10 Jul 2020 05:00:00 -0000

ros-galactic-velodyne-driver (2.0.0-1focal) focal; urgency=high

  * Fix dependencies in package.xml (#331 <https://github.com/ros-drivers/velodyne/issues/331>)
    Ensure that we depend on ament_cmake_ros as appropriate.
  * Fixes pointed out by clang-tidy (#310 <https://github.com/ros-drivers/velodyne/issues/310>)
    * Rearrange header includes so clang-tidy is happy.
    * Get rid of unnecessary void arguments on methods.
    * Properly mark methods as override where appropriate.
    * Initialize members and stack variables to zero before use.
    * Mark function implementations in header files 'inline'.
    * Use more efficient 'empty' method instead of empty string.
    * Get rid of unnecessary else statements after a continue/return.
    * Get rid of unnecessary == false use.
    * Make sure to add a virtual destructor to DataContainerBase.
    * Use string != comparison instead of 'compare' method.
    * Rename PointcloudXYZIR parameter name to match implementation.
    * Get rid of usage of typedef.
    * Be more explicit about using floats.
    * Do an explicit lround to do int->float conversion.
    * Fix the intensity calculation.
    * Remove the azimuth from addPoint.
    * Make sure to reset the cloud data to 0 before reusing.
    * Use underscores on pointcloud member variables.
    * Using std::lround means we don't need to add 0.5 to the result.
    * Slightly rearrange and simplify range checks.
    * Add in example launch files for VLP32C.
  * Dashing fixes (#307 <https://github.com/ros-drivers/velodyne/issues/307>)
    * Use std::make_unique as appropriate.
    * Fix the azimuth calculation.
    * Fix a crash during driver startup.
    * Always recalculate the row_step while setting up the cloud.
    * Make sure to call computeTransformation.
    * Fix style errors pointed out by flake8.
  * ROS2: Add Linters to velodyne_driver (#301 <https://github.com/ros-drivers/velodyne/issues/301>)
    * Renaming files to match ROS2 conventions.
    * Cleaning up velodyne_driver and fixing diags.
    * velodyne_driver linting complete.
    * VD: Removing unused namespace.
  * Add in example launch files.
  * Disable copy, move, and assign operators.
  * Build the components so the velodyne can be run as a component.
  * Add in NodeOptions to node constructors.
  * Throw an exception for an invalid Velodyne model.
  * Add explicit, final, and override to classes where appropriate.
  * Switch to using nullptr everywhere.
  * Pass read_once, read_fast, and repeat_delay to InputPCAP constructor.
  * Change filename parameter to const reference.
  * Pass the devip string into the Input* constructors.
  * Move gps_time into the InputSocket class.
  * Get rid of default parameters for Input* constructors.
  * Rename nodes.
  * Update the documentation for ROS 2.
  * Switch to using the cut angle by default.
  * Merge pull request #251 <https://github.com/ros-drivers/velodyne/issues/251> from clalancette/dashing-devel3
    ROS 2 Dashing port
  * Merge pull request #214 <https://github.com/ros-drivers/velodyne/issues/214> from spuetz/feature/opc_nopcl
    Container cleanup and organized pointclouds
  * Merge pull request #243 <https://github.com/ros-drivers/velodyne/issues/243> from dandedrick/reconfig-enable
    driver: add enabled reconfigure param
  * Merge pull request #234 <https://github.com/ros-drivers/velodyne/issues/234> from kmhallen/c++11
    Set minimum C++ standard to C++11
  * Merge pull request #231 <https://github.com/ros-drivers/velodyne/issues/231> from ros-drivers/ci/test_better_output
    CI: Adding roslint as separate step. Limiting output of catkin build.
  * Merge pull request #227 <https://github.com/ros-drivers/velodyne/issues/227> from ros-drivers/roslint
    Applying roslint to velodyne_pointcloud.
  * Merge pull request #225 <https://github.com/ros-drivers/velodyne/issues/225> from ros-drivers/roslint


=== debian/control ===
Source: ros-galactic-velodyne-driver
Section: misc
Priority: optional
Maintainer: Josh Whitley <whitleysoftwareservices@gmail.com>
Build-Depends: debhelper (>= 9.0.0), libpcap0.8-dev, ros-galactic-ament-cmake-gtest <!nocheck>, ros-galactic-ament-cmake-ros, ros-galactic-ament-lint-auto <!nocheck>, ros-galactic-ament-lint-common <!nocheck>, ros-galactic-diagnostic-msgs, ros-galactic-diagnostic-updater, ros-galactic-rclcpp, ros-galactic-rclcpp-components, ros-galactic-tf2-ros, ros-galactic-velodyne-msgs, ros-galactic-ros-workspace
Homepage: http://www.ros.org/wiki/velodyne_driver
Standards-Version: 3.9.2

Package: ros-galactic-velodyne-driver
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libpcap0.8-dev, ros-galactic-diagnostic-msgs, ros-galactic-diagnostic-updater, ros-galactic-rclcpp, ros-galactic-rclcpp-components, ros-galactic-tf2-ros, ros-galactic-velodyne-msgs, ros-galactic-ros-workspace
Description: ROS device driver for Velodyne 3D LIDARs.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/galactic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/galactic" \
		-DAMENT_PREFIX_PATH="/opt/ros/galactic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/galactic" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-galactic-velodyne-driver//opt/ros/galactic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_install
